function [nrows ncols vec] = mat_diag(A)
%Return the diagonal of the matrix A
%Input argument: matrix A
%Output argument: vector vec
%If the matrix is square return the diagonal as vector, 
%otherwise return the empty vector

%Practical exercise of Exam 2/10/2015

%Check if the matrix is square

%Use size to find the number of rows and columns of A
%nrows is the number of rows
%ncols is the number of columns
[nrows, ncols] = size(A);

if (nrows ~= ncols) %the matrix is not square
    vec = [];       %return the empty vector  
else                %the matrix is square: we need to find the diagonal
    for i=1:nrows
        vec(i) = A(i,i);
    end   
    
    %Alternative loop version using while rather than for
    %i = 1;
    %while (i <= nrows) 
        %vec(i) = A(i,i);
        %i = i+1;
    %end    
end

end