function fact = my_factorial(n)
%Returns the factorials of the first n integers

%Practical exercise of Exam 1/13/2015

if (n < 0)
    fact = [];
elseif (n == 0) 
    fact = 1;
else
    fact(1) = 1;
    for i = 2:n
        fact(i) = fact(i-1)*i;
    end
end

% A slower version with nested for loop
% if (n < 0)
%     fact = [];
% elseif (n == 0) 
%     fact = 1;
% else
%     for i = 1:n
%         fact(i) = i;
%         for j = 1:i-1
%             fact(i) = fact(i)*j; 
%         end
%     end
% end

end